#ifndef DIGEST_H
#define DIGEST_H

#include <errno.h>
#include <openssl/evp.h>
#include <string.h>

/**
 * @brief Make the digest of the given string
 *
 * @param foo
 * @param digest_method
 * @return char*
 */
char *str_digest(char *foo, char *digest_method);

/**
 * @brief Make the digest of the given file
 *
 * @param filename If null, read STDIN
 * @param digest_method
 * @return char*
 */
char *file_digest(char *filename, char *digest_method);

#endif // DIGEST_H
