#include "opt.h"

//=========================
// PUBLIC
//=========================

opt *verify_options(int argc, char *argv[]) {
    int option;
    opt *verified = malloc(sizeof(opt));
    verified->flag = 0;
    verified->digest_method = NULL;

    while ((option = getopt(argc, argv, "wfst:")) != -1) {
        // Argument list too long
        if (verified->flag != 0 && option != 't') {
            printf("Cannot choose mulitple options.\n");
            exit(E2BIG);
        }

        switch (option) {
        case 'w':
            verified->flag = 1 << 0;
            break;

        case 'f':
            verified->flag = 1 << 1;
            break;

        case 's':
            verified->flag = 1 << 2;
            break;

        case 't':
            // optarg hold the value of the current option
            verified->digest_method = optarg;
            break;

        // Invalid argument
        default:
            exit(EINVAL);
            break;
        }
    }

    if (verified->digest_method == NULL) {
        verified->digest_method = "SHA1";
    }

    verified->extra_count = argc - optind;
    verified->extra = malloc(sizeof(char *) * verified->extra_count);
    // optind not found in vscode, but the variable simply store the index
    // of the first non-argument term passed to the arguments list.
    for (int i = optind; i < argc; i++) {
        verified->extra[i - optind] = argv[i];
    }

    return verified;
}

void discard_options(opt *o) {
    free(o->extra);
    free(o);
}
